<template>
  <div 
  ref="sidebarMenuRef"
    class="v-sidebar-menu"
    :class="sidebarClass"
    :style="{'max-width': sidebarWidth}">
    <slot name="header" />
    
    <sidebar-menu-scroll>
      <div class="p-3" style="width: 290px;">
        <a href="/" class="d-flex align-items-center  link-dark text-decoration-none ">
            <img src="/img/willemse_icon40.png"  style="margin-right:2px;">
            <span class="fw-semibold vsm--header">Intranet<span style="color:#69b145!important"> Willemse</span></span>
        </a>
      </div>
      <ul
        class="vsm--menu"
        :style="{'width': sidebarWidth}"
      >
      <li><hr style="border: 1px solid ; margin: 20px;"></li>

        <sidebar-menu-item
          v-for="item in computedMenu"
          :key="item.id"
          :item="item"
        >
          <template #dropdown-icon="{ isOpen }">
            <slot
              name="dropdown-icon"
              v-bind="{ isOpen }"
            >
              <span class="vsm--arrow_default" />
            </slot>
          </template>
        </sidebar-menu-item>
      </ul>
    </sidebar-menu-scroll>
    <slot name="footer" />

    <button
      v-if="!hideToggle"
      class="vsm--toggle-btn"
      @click="onToggleClick"
    >
      <slot name="toggle-icon">
        <span class="vsm--toggle-btn_default" />
      </slot>
    </button>    
  </div>


</template>

<script lang="ts">
import { watch, getCurrentInstance, onMounted, onUnmounted, computed } from 'vue'
import SidebarMenuItem from './MenuItem.vue';
import SidebarMenuScroll from './SidebarMenuScroll.vue'
import { initSidebar } from './use/useSidebar.js'

  export default {
    name: "Sidebar",
    components: {
      SidebarMenuItem,
      SidebarMenuScroll,
    },
    props: {
      menu: {
        type: Array,
        required: true
      },
      collapsed: {
        type: Boolean,
        default: true
      },
      width: {
        type: String,
        default: '290px'
      },
      widthCollapsed: {
        type: String,
        default: '65px'
      },
      showChild: {
        type: Boolean,
        default: false
      },
      theme: {
        type: String,
        default: ''
      },
      showOneChild: {
        type: Boolean,
        default: false
      },
      rtl: {
        type: Boolean,
        default: false
      },
      relative: {
        type: Boolean,
        default: false
      },
      hideToggle: {
        type: Boolean,
        default: false
      },
      disableHover: {
        type: Boolean,
        default: false
      },
      linkComponentName: {
        type: String,
        default: undefined
      }
    },
    data(){
        return {
        }
    },
    setup(props,context){
      const {
      getSidebarRef: sidebarMenuRef,
      getIsCollapsed: isCollapsed,
      updateIsCollapsed,
      unsetMobileItem,
      updateCurrentRoute
    } = initSidebar(props, context);

    const computedMenu = computed(() => {
      let id = 0
      function transformItems (items:any) {
        function randomId () {
          return `${Date.now() + '' + id++}`
        }
        return items.map(item => {
          let idRandom =  randomId()
          return { id: idRandom, ...item, ...(item.child && { child: idRandom,...item.child }) }
        })
      }
      return transformItems(props.menu)
    })

    const sidebarWidth = computed(() => {
      return isCollapsed.value ? props.widthCollapsed : props.width
    })

    const sidebarClass = computed(() => {
      return [
        !isCollapsed.value ? 'vsm_expanded' : 'vsm_collapsed',
        props.theme ? `vsm_${props.theme}` : '',
        props.rtl ? 'vsm_rtl' : '',
        props.relative ? 'vsm_relative' : ''
      ]
    })

    const onToggleClick = () => {
      unsetMobileItem()
      updateIsCollapsed(!isCollapsed.value)
      context.emit('update:collapsed', isCollapsed.value)
    }

    watch(() => props.collapsed, (currentCollapsed) => {
      unsetMobileItem()
      updateIsCollapsed(currentCollapsed)
    })
    const router = getCurrentInstance().appContext.config.globalProperties.$router
    if (!router) {
      onMounted(() => {
        window.addEventListener('hashchange', updateCurrentRoute)
      })
      onUnmounted(() => {
        window.removeEventListener('hashchange', updateCurrentRoute)
      })
    }

    return {
      sidebarMenuRef,
      isCollapsed,
      computedMenu,
      sidebarWidth,
      sidebarClass,
      onToggleClick,
      onRouteChange: updateCurrentRoute
    }
    },
    computed: {
      routes() {
        return this.$router.options.routes;
      }      
    },
    created(){
     
    },
    methods: {

    }
  };
</script>

<style lang="scss" scoped>

</style>